

function calNode(){
    var _nodeKey;
    var _sourceKey;
    var _title;
    var _themeColor;
    var _visible;
    var _totalrecordcount;
    var _type;
    var _isAll;
    var _access;
    
    this.initWithTaggedString = function(taggedString){
        _visible = 1;
        _nodeKey = getat(taggedString, "nodekey");
        _sourceKey = getat(taggedString, "sourcekey");
        _title = getat(taggedString, "title");
        _themeColor = getat(taggedString, "themecolor");
        _visible = getat(taggedString, "visible");
        _totalrecordcount = getat(taggedString, "totalrecordcount");
        _type = getat(taggedString, "type");
        _access = getat(taggedString, "access");
        _isAll = false;
    }
    
    this.getNodeKey = function(){return _nodeKey;}
    this.getSourceKey = function(){return _sourceKey;}
    this.getTitle = function(){return _title;}
    
    this.setTitle = function(title){
        if (this.isNative()){
            var r = dobedoPlug.setNodeTitle(_nodeKey, title);
            if (r){
                _title = title;
                dobedoPlug.postNotification("calendarList");
            }
            return r;
        }else{
            return false;
        }
    }
    
    this.getSelected = function(){return _selected;}
    this.getType = function(){return _type;}
    this.getTotalRecordCount = function(){return _totalrecordcount;}
    this.getAccess = function(){return _access;}
    this.getThemeColor = function(){
        return _themeColor;
        if (this.isGroup()) return _themeColor;
            var tmp = dobedoPlug.getThemeColor(_sourceKey);
            if (tmp) _themeColor = tmp;
        return _themeColor;
    }
    
    this.setThemeColor = function(color){
        if (!dobedoPlug.setThemeColor(_nodeKey, color)) return;
        _themeColor = color;
    }
    
    this.getTypeFormated = function(){
        var r;
        
        if (this.isGroup()){
            r = "Group"
        }else{
            r = this.getType();
        }

        return r;
    }
    
    this.isGroup = function(){
        return (_type == "CALNamedGroupNode");
    }

    this.isSubscription = function(){
        return (this.getType() == "Subscription");
    }
    
    this.isBirthday = function(){
        return (this.getType() == "Birthday");
    }
    
    this.isAll = function(){
        return _isAll;
    }
    
    this.isNative = function(){
        return (this.getType() == "DoBeDo");
    }
    
    this.setAll = function(ab){
        _isAll = ab;
    }
    
    this.isVisible = function(){
        return (_visible == 1);
    }
    
    this.isReadOnly = function(){
        return (this.isSubscription() || this.isBirthday());
    }
    
    this.setVisible = function(vbool){
        _visible = (vbool) ? 1 : 0;
        dobedoPlug.setNodeVisible(_nodeKey, _visible);
    }
    
    

}
